#ifndef UNITREE_MOTOR_SERIAL_DRIVER_HPP
#define UNITREE_MOTOR_SERIAL_DRIVER_HPP

#include <chrono>
#include <memory>
#include "rclcpp/rclcpp.hpp"
#include "serialPort/SerialPort.h"
#include "unitreeMotor/unitreeMotor.h"


namespace unitree_motor_serial_driver
{

struct Motor_t
{
    MotorCmd cmd;
    MotorData data;
};

class MotorControlNode : public rclcpp::Node
{
public:
    MotorControlNode();

private:
    void control_motor();

    SerialPort serial_;
    rclcpp::TimerBase::SharedPtr timer_;
};

}

#endif